/*
  sqlpoke.cpp -		Scans a range of IPs for a port and attempts an SQL connection with
					the default sa account. If successful, a list of SQL commands is 
					sent to the server.

  I wrote this some time in early '99 for an audit I was performing.  The code
  was partly cribbed from an MSDN sample and from some other tools I've written.
  Now that the sa feature has been "re-discovered" I figure it's time to give
  this away.  SQL admins will know how to make this tool work.

  The code should be pretty easy to follow.  It's fairly simple and can be 
  modified very easily to perform a brute force attack.  I'm only a casual C 
  coder, so deal with my quirks.

  xaphan@hushmail.com
*/


#include "stdafx.h"
#include <stdio.h>
#include <winsock2.h>
#define _MT
#include <process.h>
#include <sql.h>
#include <sqlext.h>

struct ssock
{
	SOCKET sock;
	int state; // 0 = unused, 1 = active
	unsigned long target;
};

int NUM_SOCKETS = 32, cmdcount;
unsigned short port;
char commands[32][512];

unsigned __stdcall sqlcheck(void * addr)
{
	SQLHENV henv = SQL_NULL_HENV;
	SQLHDBC hdbc1 = SQL_NULL_HDBC;     
	SQLHSTMT hstmt1 = SQL_NULL_HSTMT;
	RETCODE retcode;
    SQLCHAR szName[512], szOutConn[1024] ;
    SQLINTEGER    cbName;
	SQLSMALLINT szint;
	char constr[1024], target[16];
	int count=0;
	
	strcpy(target, (char *)addr); // i suck ;>

	// Build connection string to pass to ODBC driver
	sprintf(constr, "%s%s%s", "DRIVER={SQL Server};SERVER=", target,";UID=sa;PWD="); 
	
	// error checking?
    retcode = SQLAllocHandle (SQL_HANDLE_ENV, NULL, &henv);

    retcode = SQLSetEnvAttr(henv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) SQL_OV_ODBC3, SQL_IS_INTEGER);

    retcode = SQLAllocHandle(SQL_HANDLE_DBC, henv, &hdbc1);

	// Connect to server
    retcode = SQLDriverConnect(hdbc1, NULL, (SQLTCHAR*)constr, SQL_NTS, szOutConn, 1024, &szint, SQL_DRIVER_NOPROMPT);
	
	// this error is actually important
	if (retcode == SQL_ERROR)
	{
		printf("Could not connect to %s.\n", target);
		return 0;
	}

	while ( count < cmdcount )
	{
		// Allocate a statement handle.
		retcode = SQLAllocHandle(SQL_HANDLE_STMT, hdbc1, &hstmt1);

		// Exec the statement and increment count
		retcode = SQLExecDirect(hstmt1, (SQLTCHAR*)&commands[count++][0], SQL_NTS);
		
		if (retcode == SQL_ERROR)
		{
			printf("%s - Failed on %s.\n", &commands[count - 1][0], target);
		}
		else if (retcode == SQL_NO_DATA)
		{
			printf("%s - Success on %s: No data returned.\n", &commands[count - 1][0], target);
			printf("\n---------------\n\n");
		}
		else
		{
			printf("Data Returned from %s:\n%s\n\n", target, &commands[count - 1][0]);

			retcode = SQLBindCol(hstmt1, 1, SQL_C_CHAR, szName, 512, &cbName);
			
			// Loop through the recordset and return the output
			while (retcode != SQL_NO_DATA && retcode != SQL_ERROR )
			{
				retcode = SQLFetch(hstmt1);
				printf("%s\n", szName);
			}
			printf("\n---------------\n\n");
		}
		SQLFreeHandle(SQL_HANDLE_STMT, hstmt1);
	}
	
    // Clean up. 
    SQLDisconnect(hdbc1);
    SQLFreeHandle(SQL_HANDLE_DBC, hdbc1);
    SQLFreeHandle(SQL_HANDLE_ENV, henv);

    return(0);

}

void usage(void)
{
	printf("  \nUSAGE:\tsqlpoke [Start IP] [End IP] [Port] [Command File]\n\n\tNo more than 32 Commands allowed.\n\n");
	return;
}

//this function takes 2 IPs and returns an array of network IPs
int gettargets(char *startip, char *endip, unsigned long *list)
{
	unsigned long saddr, eaddr, walker;
	long l=0;
	int soct0, soct1, soct2, soct3, eoct0, eoct1, eoct2, eoct3;

	saddr=ntohl(inet_addr(startip));
	
	if ( saddr == INADDR_NONE )
		return 1;

	soct0=(saddr >> 24) & 255;
	soct1=(saddr >> 16) & 255;
	soct2=(saddr >> 8) & 255;
	soct3=(saddr) & 255;

	eaddr=ntohl(inet_addr(endip));
	
	if ( eaddr == INADDR_NONE )
		return 1;

	eoct0=(eaddr >> 24) & 255;
	eoct1=(eaddr >> 16) & 255;
	eoct2=(eaddr >> 8) & 255;
	eoct3=(eaddr) & 255;

	if (saddr > eaddr)
	{
		printf("\nEnter a valid range.\n\n");
		return 1;
	}

	if ((soct0 != eoct0) || (soct1 != eoct1))
	{
		printf("\nsqlpoke can only scan a class B network. Try again.\n\n");
		return 1;
	}

	walker=saddr;
	while (walker!=eaddr+1)
	{
		list[l]=walker;
		walker++, l++;
	}

	while ( l < 65536 )
	{
		list[l] = 0;
		l++;
	}

	return 0;
}

//scan each address for the port
int scan(unsigned long list[65536])
{
	struct ssock sock[512];
	WSADATA wsadata;
	fd_set fdset;
	unsigned long on=1, off=0;
	struct timeval tv= {0,0};
	struct sockaddr_in sint;
	int res = 0, i = 0, itarget = 0, iwaiting = 0, oct0, oct1, oct2, oct3;
	long count = 0;
	char ip[16];
	UINT thridx;

	WSAStartup(MAKEWORD (2,2), &wsadata );

	sint.sin_family = AF_INET;
	sint.sin_port = htons(port);

	for ( i=0; i<NUM_SOCKETS; i++)
	{
		sock[i].state = 0;
	}

	while ( 1 )
	{
		// loop through array and check state, start all idle sockets
		for ( i=0; i<NUM_SOCKETS; i++)
		{
			if ( sock[i].state == 0 )
			{	// give the sock a target if there is another
				if (list[itarget] != 0)
				{
					if ((sock[i].sock = socket( AF_INET, SOCK_STREAM, 0 )) != INVALID_SOCKET)
					{	// socket was created, set the timeout
						if (setsockopt(sock[i].sock, SOL_SOCKET , SO_SNDTIMEO, "10000", sizeof("10000")) == 0)
						{	// timeout was set, initialize sockaddr_in and connect
							ioctlsocket(sock[i].sock,FIONBIO,&on); // non-blocking
							sint.sin_addr.s_addr = htonl(list[itarget]);
							sock[i].target = list[itarget];
							connect(sock[i].sock, (struct sockaddr*)&sint, sizeof(sint));
							sock[i].state = 1; // active
							itarget++;
						}
						else
						{
							printf("setsockopt() failed... you have problems.\n");
							WSACleanup();
							return 1;
						}
					}
					else
						printf("Crapped out on socket()\n");
				}
			}
		}

		FD_ZERO(&fdset);
		for ( i=0; i<NUM_SOCKETS; i++)
		{	// add all active sockets to the fdset
			if (sock[i].state == 1)
			{
				FD_SET(sock[i].sock,&fdset);
			}
		}

		// check for sockets that connected
		select(0,NULL,&fdset,NULL,&tv);
		for ( i=0; i<NUM_SOCKETS; i++)
		{
			if (FD_ISSET(sock[i].sock,&fdset))
			{
				// Successful connect!
				oct0=(sock[i].target >> 24) & 255;
				oct1=(sock[i].target >> 16) & 255;
				oct2=(sock[i].target >> 8) & 255;
				oct3=(sock[i].target) & 255;
				sprintf(ip, "%d.%d.%d.%d", oct0, oct1, oct2, oct3);

				//printf("%s\n", ip);
				closesocket(sock[i].sock);
				sock[i].state = 0;

				// Spawn thread to check for sql server
				// (I know, I know... I'm too lazy to fix this.)
				_beginthreadex(NULL, 0, sqlcheck,(void *)strdup(ip),0, &thridx);
				Sleep(100); // The Pause that Refreshes
			}
		}

		FD_ZERO(&fdset);
		for ( i=0; i<NUM_SOCKETS; i++)
		{	// add all active sockets to the fdset
			if (sock[i].state == 1)
				FD_SET(sock[i].sock,&fdset);
		}

		// check for dead sockets
		select(0,NULL,NULL,&fdset,&tv);
		for ( i=0; i<NUM_SOCKETS; i++)
		{
			if (FD_ISSET(sock[i].sock,&fdset))
			{	// error connecting
				ioctlsocket(sock[i].sock,FIONBIO,&off);
				closesocket(sock[i].sock);
				sock[i].state = 0;
			}
		}
		
		iwaiting = 0;
		for ( i=0; i<NUM_SOCKETS; i++)
		{
			if ( sock[i].state != 0 )
				iwaiting = 1;
		}

		if ( iwaiting == 0 && list[itarget] == 0)
		{	// no sockets are active & no more targets
			printf("\nScan complete.\n");
			WSACleanup();
			return 0;
		}
		
		count++;

		Sleep(100);
	}
	
	printf("Socket scan complete.\n");
	WSACleanup();
	return 0;
}

int main(int argc, char* argv[])
{
	unsigned long targets[65536];
	unsigned short lPort = 0;
	FILE  *cmd;
	int count=0, cc = 0;


	if (argc != 5)
	{
		usage();
		return 0;
	}

	// get target IPs
	if (gettargets(argv[1], argv[2], targets) == 1)
	{
		// error messages are handled in the function
		return 0;
	}

	// get port number
	if ((port = atoi(argv[3])) == 0)
	{	//not a number
		printf("Invalid port number.\n");
		return 0;
	}

	if ( 0 > port || port > 65535 )
	{
		printf("Invalid port number.\n");
		return 0;
	}	
	
	//open command file and read commands in to array
	if ( (cmd = fopen(argv[4], "r")) == NULL)
	{
		printf("Could not open command file.\n");
		return 0;
	}
	else
	{  // one command per line
		while ( fgets( &commands[count][0], 512, cmd ) != NULL )
		{
			while (commands[count][cc] != NULL)
			{
				if (commands[count][cc] == '\n')
					commands[count][cc] = NULL;
				cc++;
			}
			if (count++ > 32)
				break;
			cc = 0;
		}
	}

	cmdcount = count;
	
	printf("\n");
	// scan the range
	scan(targets);
	
	return 0;
}
